//---------------------------------------------------------------------------

#ifndef ObjectsH
#define ObjectsH

#include "CLevel.h"

//  
#define GO_PLAYER 1      // 
#define GO_ENEMY1 2      // 1
#define GO_LEVEL  100    //  

// Sprite Actions -  
#define SA_STILL 100   // 
#define SA_WALK  101   // 
#define SA_FALL  102   // 
#define SA_CLIMB 103   //   


//     
class Game_Object;
#define GM_DIE 10  //        
#define GM_FALL 20  //    ,          .
#define GM_GROUND 30  //  ,         
#define GM_INTOGROUND 40  //      
#define GM_NOGROUND  50  // ,       
#define GM_INTOGROUND_X 60  //       
                            // (    ,   ,    )
//#define GM_

struct Game_Message
{
int type;
int param;
Game_Object *Sender;
};


//    NDX_Sprites   Game_Control
//      
class Game_Control : public NDX_SpriteControl
{
public:
    void Analize();

private:

};



//  -  
class Game_Object : public NDX_Sprite
{
public:
    float x,y;
    float frame;  //   
    int prev_x, prev_y;  //  
    float div_x,div_y;   //     
    int action;  //     
    NDX_FrameList Frames;  //    
    int type;   //  
    void Draw();
    Game_Object();
    virtual void Create(LEVFILEOBJECT *levobj);
    virtual void CheckForHits( NDX_SpriteControl *Sprites ){};
};

//  - 
class GO_Level : public Game_Object
{
public:
    CLevel Level;
    void Draw();
  __fastcall GO_Level(char *name);
    void CheckForHits(NDX_SpriteControl *Sprites);
    int isPassingTile(int pixel_x,int pixel_y);
    int isGroundTile(int pixel_x,int pixel_y);
};


class GO_Player : public Game_Object
{
public:
    GO_Player();
    void Move(double);
    void CheckForHits(NDX_SpriteControl *Sprites);
    void Message(void *msg);
private:
    BOOL bCanClimbUp;  //      
    BOOL bCanClimbDown;  //      
};

class GO_Enemy1 : public Game_Object
{
public:
    GO_Enemy1();
    void Move(double);
};


//---------------------------------------------------------------------------
#endif
